package{
  import flash.geom.Point;
  import steamtable.SaturatedVapor;
  import steamtable.StateVariable;
  import steamtable.SteamTable;
  import steamtable.SteamTableData;

//--------------------------------------------------------------------//
// LTCN
  public class RankineCycle{

// ͍ől
    public static const P_MAX:Number=50.0;

// `捏
    public static const INC:int=20;

// C\
    public var table:SteamTable;

// ሳ
    public var p1:Number;

// 
    public var p2:Number;

// ^[rCx
    public var t3:Number;

// ^[rd
    public var wt:Number;

// |vd
    public var wp:Number;

// {C[ŉM
    public var q1:Number;

// ŕMM
    public var q2:Number;

// M
    public var efficiency:Number;

// P-V }̓_i[z
    protected var pv:Vector.<Point>;

// T-S }̓_i[z
    protected var ts:Vector.<Point>;

// |v̏ԗ
    public var sv1:StateVariable;

// |vȍԗ
    public var sv2:StateVariable;

// ^[ȑԗ
    public var sv3:StateVariable;

// ^[rȍԗ
    public var sv4:StateVariable;

//--------------------------------------------------------------------//
    public function RankineCycle(){
      table=new SteamTable();
      p1=0.0;
      p2=0.0;
      t3=0.0;
      wt=0.0;
      wp=0.0;
      q1=0.0;
      q2=0.0;
      efficiency=0.0;
      pv=new Vector.<Point>();
      ts=new Vector.<Point>();
    }

//--------------------------------------------------------------------//
// TCNݒ肷
// p1 - ሳ
// p2 - 
// t3 - ^[rCx
    public function setCondition(p1:Number,p2:Number,t3:Number):void{
      var sv:SaturatedVapor=table.saturatedVapor;
      if(p1>=p2){
      	throw new Error("P1>=P2");
      }
      else if(p1<=sv.getTripleP()){
      	throw new Error("P1<=Triple point");
      }
      else if(p1>=sv.getCriticalP()){
      	throw new Error("P1>=Critical point");
      }
      else if(p2>P_MAX){
      	throw new Error("P2>Limit pressure");
      }
      else if(t3<=sv.getGasByP(p2).t){
      	throw new Error("T3<=Saturated point");
      }
      this.p1=p1;
      this.p2=p2;
      this.t3=t3;
    }

//--------------------------------------------------------------------//
// }f[^𒊏o
    public function createDiagram():void{
      pv.length=0;
      ts.length=0;
      var sv:SaturatedVapor=table.saturatedVapor;
      var hv:SteamTableData=table.heatedVapor;
      var cw:SteamTableData=table.compressedWater;
      sv1=sv.getLiquidByP(p1);
      addPoint(sv1);
      sv2=cw.getByPS(p2,sv1.s);
      addPoint(sv2);
// QR
      var t21:Number=sv.getCriticalT();
      if(p2<sv.getCriticalP()){
      	var sv21:StateVariable=sv.getLiquidByP(p2);
      	var ds:Number=(sv21.s-sv1.s)/Number(INC);
      	for(var i:int=1;i<INC;i++){
      	  addPoint(cw.getByPS(p2,sv1.s+ds*Number(i)));
      	}
      	addPoint(sv21);
      	var sv22:StateVariable=sv.getGasByP(p2);
      	addPoint(sv22);
      	t21=sv22.t;
      }
      else{
      	var dt:Number=(t21-sv2.t)/Number(INC);
      	for(i=1;i<=INC;i++){
      	  addPoint(cw.getByPT(p2,sv2.t+dt*Number(i)));
      	}
      }
      dt=(t3-t21)/Number(INC);
      for(i=1;i<INC;i++){
      	addPoint(hv.getByPT(p2,t21+dt*Number(i)));
      }
      sv3=hv.getByPT(p2,t3);
      addPoint(sv3);
// RS
      var sv31:StateVariable=sv.getGasByS(sv3.s);
      if(sv31.t>=sv1.t){
      	var dp:Number=(sv31.p-p2)/Number(INC);
      	for(i=1;i<=INC;i++){
      	  addPoint(hv.getByPS(p2+dp*Number(i),sv3.s));
      	}
      	addPoint(sv31);
      	dp=(p1-sv31.p)/Number(INC);
      	for(i=1;i<INC;i++){
      	  var sv32:StateVariable=sv.getGasByP(sv31.p+dp*Number(i));
      	  var sr:Number=(sv3.s-sv1.s)/(sv32.s-sv1.s);
      	  pv.push(new Point(sv1.v+sr*(sv32.v-sv1.v),sv32.p));
      	  ts.push(new Point(sv3.s,sv32.t));
      	}
      	sv4=sv.getGasByP(p1);
      	sr=(sv3.s-sv1.s)/(sv4.s-sv1.s);
      	sv4.p=p1;
      	sv4.v=sv1.v+sr*(sv4.v-sv1.v);
      	sv4.u=sv1.u+sr*(sv4.u-sv1.u);
      	sv4.h=sv1.h+sr*(sv4.h-sv1.h);
      	sv4.s=sv3.s;
      	addPoint(sv4);
      }
      else{
      	dp=(p1-p2)/Number(INC);
      	for(i=1;i<INC;i++){
      	  addPoint(hv.getByPS(p2+dp*Number(i),sv3.s));
      	}
      	sv4=hv.getByPS(p1,sv3.s);
      	addPoint(sv4);
      	var sv41:StateVariable=sv.getGasByP(p1);
      	ds=(sv41.s-sv4.s)/Number(INC);
      	for(i=1;i<INC;i++){
      	  addPoint(hv.getByPS(p1,sv4.s+ds*Number(i)));
      	}
      	addPoint(sv41);
      }
      wp=sv2.h-sv1.h;
      wt=sv3.h-sv4.h;
      q1=sv3.h-sv2.h;
      q2=sv4.h-sv1.h;
      efficiency=(wt-wp)/q1;
    }

//--------------------------------------------------------------------//
// f[^_ǉ
// sv - ԗ
    protected function addPoint(sv:StateVariable):void{
      pv.push(new Point(sv.v,sv.p));
      ts.push(new Point(sv.s,sv.t));
    }

//--------------------------------------------------------------------//
// P-V }̖Oatf[^Ԃ
    public function getLiquidPV():Vector.<Point>{
      return table.saturatedVapor.getLiquidPV();
    }

//--------------------------------------------------------------------//
// T-S }̖Oatf[^Ԃ
    public function getLiquidTS():Vector.<Point>{
      return table.saturatedVapor.getLiquidTS();
    }

//--------------------------------------------------------------------//
// P-V }̖OaCf[^Ԃ
    public function getGasPV():Vector.<Point>{
      return table.saturatedVapor.getGasPV();
    }

//--------------------------------------------------------------------//
// T-S }̖OaCf[^Ԃ
    public function getGasTS():Vector.<Point>{
      return table.saturatedVapor.getGasTS();
    }

//--------------------------------------------------------------------//
// P-V }̖OatECf[^Ԃ
    public function getSaturatedPV():Vector.<Point>{
      var p1:Vector.<Point>=table.saturatedVapor.getLiquidPV();
      var p2:Vector.<Point>=table.saturatedVapor.getGasPV();
      var p:Vector.<Point>=new Vector.<Point>(2*p1.length-1,true);
      for(var i:int=0;i<p1.length;i++){
      	p[i]=p1[i].clone();
      	p[p1.length-1+i]=p2[i].clone();
      }
      return p;
    }

//--------------------------------------------------------------------//
// T-S }̖OatECf[^Ԃ
    public function getSaturatedTS():Vector.<Point>{
      var p1:Vector.<Point>=table.saturatedVapor.getLiquidTS();
      var p2:Vector.<Point>=table.saturatedVapor.getGasTS();
      var p:Vector.<Point>=new Vector.<Point>(2*p1.length-1,true);
      for(var i:int=0;i<p1.length;i++){
      	p[i]=p1[i].clone();
      	p[p1.length-1+i]=p2[i].clone();
      }
      return p;
    }

//--------------------------------------------------------------------//
// P-V }f[^Ԃ
    public function getPV():Vector.<Point>{
      var p:Vector.<Point>=new Vector.<Point>(pv.length,true);
      for(var i:int=0;i<pv.length;i++) p[i]=pv[i].clone();
      return p;
    }

//--------------------------------------------------------------------//
// T-S }f[^Ԃ
    public function getTS():Vector.<Point>{
      var p:Vector.<Point>=new Vector.<Point>(ts.length,true);
      for(var i:int=0;i<ts.length;i++) p[i]=ts[i].clone();
      return p;
    }
  }
}
