package{
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.geom.Point;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import component.ViewModel;
  import graph.GraphWindow;

//--------------------------------------------------------------------//
// LTCN\f
  public class RankineCycleViewModel extends ViewModel{

// LTCN
    internal var cycle:RankineCycle;

// G[bZ[W
    internal var message:TextField;

// eLXg{bNX
    internal var info:InfoBox;

// wiF
    internal var bgColor:uint;

// OiF
    internal var fgColor:uint;

// F
    internal var subColor:uint;

// P-V }
    internal var pvWindow:GraphWindow;

// T-S }
    internal var tsWindow:GraphWindow;

//--------------------------------------------------------------------//
// sprite - eXvCg
// cycle - LTCN
// graphics - `OtBbNX
// x,y,width,height - \ʒuAA
// bgColor - wiF
// fgColor - OiF
// subColor - F
// textFormat - eLXg
    public function RankineCycleViewModel(sprite:Sprite,
      	      	      	      	      	  cycle:RankineCycle,
      	      	      	      	      	  graphics:Graphics,x:int,y:int,
      	      	      	      	      	  width:int,height:int,
      	      	      	      	      	  bgColor:uint,fgColor:uint,
      	      	      	      	      	  subColor:uint,
      	      	      	      	      	  textFormat:TextFormat){
      super(graphics,x,y,width,height);
      this.cycle=cycle;

      this.bgColor=bgColor;
      this.fgColor=fgColor;
      this.subColor=subColor;

      message=new TextField();
      message.defaultTextFormat=textFormat;
      message.textColor=fgColor;
      message.backgroundColor=bgColor;
      message.selectable=false;
      message.text="";
      message.x=cx;
      message.y=cy;
      info=new InfoBox(fgColor,textFormat);
      info.visible=false;
      pvWindow=new GraphWindow
      	(sprite,"V[m3/kg]",true,"P[MPa]",false,textFormat);
      tsWindow=new GraphWindow
      	(sprite,"S[kJ/kgK]",false,"T[degC]",false,textFormat);
      sprite.addChild(info);
      sprite.addChild(message);
      setBorders();
      pvWindow.setAxis();
      tsWindow.setAxis();
    }

//--------------------------------------------------------------------//
// G[bZ[Wݒ肷
    public function setMessage(text:String):void{
      message.text=text;
      message.x=cx-message.textWidth/2;
      message.width=message.textWidth+5;
      info.visible=(text=="");
    }

//--------------------------------------------------------------------//
// `拫Eݒ肷
    protected function setBorders():void{
      var x:Number=region.x+region.width/10;
      var y:Number=region.y+region.height/10;
      var w:Number=7*region.width/20;
      var h:Number=4*region.height/10;
      pvWindow.setBorder(x,y,w,h);
      tsWindow.setBorder(x+region.width/2,y,w,h);
      info.x=x;
      info.y=y+region.height/2;
    }

//--------------------------------------------------------------------//
// `f[^ݒ肷
    public function setDrawData():void{
      pvWindow.setData(cycle.getSaturatedPV(),cycle.getPV());
      tsWindow.setData(cycle.getSaturatedTS(),cycle.getTS());
      pvWindow.setAxis();
      tsWindow.setAxis();
      info.setData(cycle);
    }

//--------------------------------------------------------------------//
// `悷
    public function draw():void{
      drawInit(bgColor);
      if(message.text!=""){
      	pvWindow.clearLabel();
      	tsWindow.clearLabel();
      }
      else{
      	pvWindow.paint(fgColor,subColor);
      	tsWindow.paint(fgColor,subColor);
      	info.draw();
      }
    }
  }
}
