package graph{
  import flash.display.Sprite;
  import flash.text.TextField;
  import flash.text.TextFormat;

//--------------------------------------------------------------------//
// Ot
  public class GraphAxis{

// ڐ`TCY
    public static const SCALE_SIZE:int=4;

// eXvCg
    internal var sprite:Sprite;

// x
    internal var label:TextField;

// ڐlx
    internal var scaleLabel:Vector.<TextField>;

// ͈͍ŏl
    internal var scaleMin:Number;

// ͈͍ől
    internal var scaleMax:Number;

// ڐ
    internal var scale:Number;

// f[^|`ʒuϊW
    internal var coef1:Number;

// f[^|`ʒuϊW
    internal var coef0:Number;

// `
    internal var lines:DrawLines;

//--------------------------------------------------------------------//
// sprite - eXvCg
// text - x
// textFormat - eLXg
    public function GraphAxis(sprite:Sprite,text:String,
      	      	      	      textFormat:TextFormat){
      this.sprite=sprite;
      label=new TextField();
      label.defaultTextFormat=textFormat;
      label.selectable=false;
      label.text=text;
      sprite.addChild(label);
      scaleMin=0.0;
      scaleMax=1.0;
      scale=1.0;
      coef1=1.0;
      coef0=0.0;
      setScaleLabel();
    }

//--------------------------------------------------------------------//
// x
    public function clearLabel():void{
      for(var i:int=0;i<scaleLabel.length;i++){
      	if(sprite.contains(scaleLabel[i])){
      	  sprite.removeChild(scaleLabel[i]);
      	  delete scaleLabel[i];
      	}
      }
    }

//--------------------------------------------------------------------//
// Otڐݒ肷
// minValue - f[^ŏl
// maxValue - f[^ől
    public function setScale(minValue:Number,maxValue:Number):void{
      if(scaleLabel!=null) clearLabel();
      if(minValue>=maxValue){
      	scaleMin=maxValue;
      	scaleMax=scaleMin+1.0;
      	scale=1.0;
      }
      else{
      	var xm:Number=Math.max(Math.abs(minValue),Math.abs(maxValue));
      	xm=Math.min(xm,maxValue-minValue);
      	scale=Math.pow(10.0,Math.floor(Math.log(xm)/Math.log(10.0)));
      	scaleMin=scale*Math.floor(minValue/scale);
      	if(scaleMin==minValue) scaleMin-=scale;
      	scaleMax=scale*Math.ceil(maxValue/scale);
      	if(scaleMax==maxValue) scaleMax+=scale;
      }
      setScaleLabel();
    }

//--------------------------------------------------------------------//
// Otڐxݒ肷
    protected function setScaleLabel():void{
      var count:int=int((scaleMax-scaleMin)/scale)+1;
      scaleLabel=new Vector.<TextField>(count,true);
      lines=new DrawLines(2*count+2);
      for(var i:int=0;i<count;i++){
      	scaleLabel[i]=new TextField();
      	scaleLabel[i].defaultTextFormat=label.defaultTextFormat;
      	scaleLabel[i].selectable=false;
      	scaleLabel[i].text=toLabel(scaleMin+scale*i);
      	sprite.addChild(scaleLabel[i]);
      }
    }

//--------------------------------------------------------------------//
// Wݒ肷
// p0 ʒu
// range \͈
// direc @1F@-1F
    public function setCoef(p0:int,range:int,direc:int):void{
      coef1=Number(direc*range)/(scaleMax-scaleMin);
      coef0=Number(p0)-coef1*scaleMin;
    }

//--------------------------------------------------------------------//
// f[^`ʒuɕϊ
// x f[^
    public function toView(x:Number):int{
      return int(coef1*x+coef0);
    }

//--------------------------------------------------------------------//
// `ʒuf[^ɕϊ
// x `ʒu
    public function toData(x:Number):Number{
      return (x-coef0)/coef1;
    }

//--------------------------------------------------------------------//
// `悷
// x0 - xW
// y0 - yW
// width - \
    public function paintHorizontal(x0:Number,y0:Number,
      	      	      	      	    width:Number):void{
      lines.setLine(0,x0,y0,x0+width,y0);
      var ty:int=y0+1;
      for(var i:int=0;i<scaleLabel.length;i++){
      	var x:int=fromScaleToView(scaleMin+scale*i);
      	lines.setLine(i+1,x,y0,x,y0-SCALE_SIZE);
      	scaleLabel[i].x=x-scaleLabel[i].textWidth/2;
      	scaleLabel[i].y=ty;
      }
      label.x=x0+(width-label.textWidth)/2;
      label.y=ty+label.textHeight;
      lines.draw(sprite.graphics);
      lines=null;
    }

//--------------------------------------------------------------------//
// `悷
// x0 - xW
// y0 - yW
// height - \
    public function paintVertical(x0:Number,y0:Number,
      	      	      	      	  height:Number):void{
      lines.setLine(0,x0,y0,x0,y0+height);
      var dy:int=label.textHeight/2+2;
      for(var i:int=0;i<scaleLabel.length;i++){
      	var y:int=fromScaleToView(scaleMin+scale*i);
      	lines.setLine(i+1,x0,y,x0+SCALE_SIZE,y);
      	scaleLabel[i].x=x0-scaleLabel[i].textWidth-2;
      	scaleLabel[i].y=y-dy;
      }
      label.x=x0-label.textWidth/2;
      label.y=y0-label.textHeight*3/2;
      lines.draw(sprite.graphics);
      lines=null;
    }

//--------------------------------------------------------------------//
// ڐ̐l𕶎ɕϊ
    protected function toLabel(s:Number):String{
      return String(s);
    }

//--------------------------------------------------------------------//
// ڐ̐l`ʒuɕϊ
    protected function fromScaleToView(s:Number):int{
      return toView(s);
    }
  }
}
