package graph{
  import flash.display.Sprite;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.text.TextFormat;

//--------------------------------------------------------------------//
// Ot
  public class GraphWindow{

// eXvCg
    protected var sprite:Sprite;

// OaC}̓_f[^i[z
    protected var p1:Vector.<Point>;

// TCN̓_f[^i[z
    protected var p2:Vector.<Point>;

// `̈
    protected var region:Rectangle;

// x
    protected var xAxis:GraphAxis;

// y
    protected var yAxis:GraphAxis;

// `
    internal var lines:DrawLines;

//--------------------------------------------------------------------//
    public function GraphWindow(sprite:Sprite,
      	      	      	      	xLabel:String,xIsLog:Boolean,
      	      	      	      	yLabel:String,yIsLog:Boolean,
      	      	      	      	textFormat:TextFormat){
      this.sprite=sprite;
      if(xIsLog){
      	xAxis=new LogAxis(sprite,xLabel,textFormat);
      }
      else{
      	xAxis=new GraphAxis(sprite,xLabel,textFormat);
      }
      if(yIsLog){
      	yAxis=new LogAxis(sprite,yLabel,textFormat);
      }
      else{
      	yAxis=new GraphAxis(sprite,yLabel,textFormat);
      }
      region=new Rectangle();
    }

//--------------------------------------------------------------------//
// Eݒ肷
// x,y,width,height - \ʒuAA
    public function setBorder(x:Number,y:Number,
      	      	      	      width:Number,height:Number):void{
      region.x=x;
      region.y=y;
      region.width=width;
      region.height=height;
    }

//--------------------------------------------------------------------//
// f[^ݒ肷
// p1 - OaC}̓_f[^i[z
// p2 - TCN̓_f[^i[z
    public function setData(p1:Vector.<Point>,p2:Vector.<Point>):void{
      this.p1=p1;
      this.p2=p2;
    }

//--------------------------------------------------------------------//
// x
    public function clearLabel():void{
      xAxis.clearLabel();
      yAxis.clearLabel();
    }

//--------------------------------------------------------------------//
// f[^ݒ肷
    public function setAxis():void{
      if((p2!=null) && (p2.length>0)){
      	var large:Number=Number.MAX_VALUE;
      	var xMin:Number=large;
      	var xMax:Number=-large;
      	var yMin:Number=large;
      	var yMax:Number=-large;
      	for(var i:int=0;i<p2.length;i++){
      	  xMin=Math.min(xMin,p2[i].x);
      	  xMax=Math.max(xMax,p2[i].x);
      	  yMin=Math.min(yMin,p2[i].y);
      	  yMax=Math.max(yMax,p2[i].y);
      	}
      	xAxis.setScale(xMin,xMax);
      	yAxis.setScale(yMin,yMax);
      }
      xAxis.setCoef(region.x,region.width,1);
      yAxis.setCoef(region.bottom,region.height,-1);
    }

//--------------------------------------------------------------------//
// Ot`悷
// fgColor - OiF
// subColor - F
    public function paint(fgColor:uint,subColor:uint):void{
      sprite.graphics.lineStyle(1,subColor);
      paintData(p1,false);
      sprite.graphics.lineStyle(1,fgColor);
      paintData(p2,true);
      paintBorder();
    }

//--------------------------------------------------------------------//
// Otf[^`悷
// p - _f[^i[z
// closed - OtĂꍇ true
    protected function paintData(p:Vector.<Point>,closed:Boolean):void{
      if((p==null) || (p.length==0)) return;
      var length:int=p.length;
      if(closed) length++;
      var x1:int=xAxis.toView(p[0].x);
      var y1:int=yAxis.toView(p[0].y);
      lines=new DrawLines();
      var contain1:Boolean=region.contains(x1,y1);
      for(var i:int=1;i<length;i++){
      	var ii:int=i%p.length;
      	var x2:int=xAxis.toView(p[ii].x);
      	var y2:int=yAxis.toView(p[ii].y);
      	var contain2:Boolean=region.contains(x2,y2);
      	if(contain1 && contain2){
      	  lines.drawLine(x1,y1,x2,y2);
      	}
      	else if(contain1){
      	  paintLineBorders(x1,y1,x2,y2);
      	}
      	else if(contain2){
      	  paintLineBorders(x2,y2,x1,y1);
      	}
        x1=x2;
        y1=y2;
        contain1=contain2;
      }
      lines.draw(sprite.graphics);
      lines=null;
    }

//--------------------------------------------------------------------//
// gׂOt`悷
// x1 - ̈̓_xW
// y1 - ̈̓_yW
// x2 - ̈O̓_xW
// y2 - ̈O̓_yW
    protected function paintLineBorders(x1:Number,y1:Number,
      	      	      	      	      	x2:Number,y2:Number):void{
      if(x2<region.x){
      	var yy:Number=(y2-y1)*(region.x-x1)/(x2-x1)+y1;
      	if(yy<region.y){
      	  var xx:Number=(x2-x1)*(region.y-y1)/(y2-y1)+x1;
      	  lines.drawLine(x1,y1,xx,region.y);
      	}
      	else if(yy>region.bottom){
      	  xx=(x2-x1)*(region.bottom-y1)/(y2-y1)+x1;
      	  lines.drawLine(x1,y1,xx,region.bottom);
      	}
      	else{
      	  lines.drawLine(x1,y1,region.x,yy);
      	}
      }
      else if(x2>region.right){
      	yy=(y2-y1)*(region.right-x1)/(x2-x1)+y1;
      	if(yy<region.y){
      	  xx=(x2-x1)*(region.y-y1)/(y2-y1)+x1;
      	  lines.drawLine(x1,y1,xx,region.y);
      	}
      	else if(yy>region.bottom){
      	  xx=(x2-x1)*(region.bottom-y1)/(y2-y1)+x1;
      	  lines.drawLine(x1,y1,xx,region.bottom);
      	}
      	else{
      	  lines.drawLine(x1,y1,region.right,yy);
      	}
      }
      else if(y2<region.y){
      	xx=(x2-x1)*(region.y-y1)/(y2-y1)+x1;
      	lines.drawLine(x1,y1,xx,region.y);
      }
      else if(y2>region.bottom){
      	xx=(x2-x1)*(region.bottom-y1)/(y2-y1)+x1;
      	lines.drawLine(x1,y1,xx,region.bottom);
      }
    }

//--------------------------------------------------------------------//
// Otg`悷
    protected function paintBorder():void{
      sprite.graphics.drawRect(region.x,region.y,
      	      	      	       region.width,region.height);
      xAxis.paintHorizontal(region.x,region.bottom,region.width);
      yAxis.paintVertical(region.x,region.y,region.height);
    }
  }
}
