package steamtable{
  import flash.geom.Point;

//--------------------------------------------------------------------//
// OaCf[^
  public class SaturatedVapor{

// xi[z
    public var t:Vector.<Number>;

// ͂i[z
    public var p:Vector.<Number>;

// t̑p[^i[z
    public var vvf:Vector.<VaporVariable>;

// Cp[^i[z
    public var vvg:Vector.<VaporVariable>;

//--------------------------------------------------------------------//
// f[^ݒ肷
// count - f[^
    public function setCount(count:int):void{
      t=new Vector.<Number>(count,true);
      p=new Vector.<Number>(count,true);
      vvf=new Vector.<VaporVariable>(count,true);
      vvg=new Vector.<VaporVariable>(count,true);
    }

//--------------------------------------------------------------------//
// f[^ݒ肷
// index - f[^̃CfbNX
// t - x
// p - 
// vvf - t̑p[^
// vvg - Cp[^
    public function setParameter(index:int,t:Number,p:Number,
      	      	      	      	 vvf:VaporVariable,
      	      	      	      	 vvg:VaporVariable):void{
      this.t[index]=t;
      this.p[index]=p;
      this.vvf[index]=vvf;
      this.vvg[index]=vvg;
    }

//--------------------------------------------------------------------//
// P-V }̖Oatf[^Ԃ
    public function getLiquidPV():Vector.<Point>{
      var pt:Vector.<Point>=new Vector.<Point>(p.length,true);
      for(var i:int=0;i<p.length;i++){
      	pt[i]=new Point(vvf[i].v,p[i]);
      }
      return pt;
    }

//--------------------------------------------------------------------//
// T-S }̖Oatf[^Ԃ
    public function getLiquidTS():Vector.<Point>{
      var pt:Vector.<Point>=new Vector.<Point>(t.length,true);
      for(var i:int=0;i<t.length;i++){
      	pt[i]=new Point(vvf[i].s,t[i]);
      }
      return pt;
    }

//--------------------------------------------------------------------//
// P-V }̖OaCf[^Ԃ
    public function getGasPV():Vector.<Point>{
      var pt:Vector.<Point>=new Vector.<Point>(p.length,true);
      for(var i:int=0;i<p.length;i++){
      	pt[p.length-1-i]=new Point(vvg[i].v,p[i]);
      }
      return pt;
    }

//--------------------------------------------------------------------//
// T-S }̖OaCf[^Ԃ
    public function getGasTS():Vector.<Point>{
      var pt:Vector.<Point>=new Vector.<Point>(t.length,true);
      for(var i:int=0;i<t.length;i++){
      	pt[t.length-1-i]=new Point(vvg[i].s,t[i]);
      }
      return pt;
    }

//--------------------------------------------------------------------//
// Od_̈͂Ԃ
    public function getTripleP():Number{
      return p[0];
    }

//--------------------------------------------------------------------//
// Od_̉xԂ
    public function getTripleT():Number{
      return t[0];
    }

//--------------------------------------------------------------------//
// ՊE͂Ԃ
    public function getCriticalP():Number{
      return p[p.length-1];
    }

//--------------------------------------------------------------------//
// ՊExԂ
    public function getCriticalT():Number{
      return t[t.length-1];
    }

//--------------------------------------------------------------------//
// ͂ɑΉOatf[^Ԃ
// pp - 
    public function getLiquidByP(pp:Number):StateVariable{
      if(pp<=p[0]){
      	return StateVariable.create(t[0],pp,vvf[0]);
      }
      else if(pp>=p[p.length-1]){
      	return StateVariable.create(t[p.length-1],pp,vvf[p.length-1]);
      }
      else{
      	var i:int=PressureTable.serachIndex(0,p.length-1,pp,p);
      	var cc:Number=(pp-p[i])/(p[i+1]-p[i]);
      	return new StateVariable(t[i]+cc*(t[i+1]-t[i]),pp,
      	      	      	      	 vvf[i].v+cc*(vvf[i+1].v-vvf[i].v),
      	      	      	      	 vvg[i].u+cc*(vvg[i+1].u-vvg[i].u),
      	      	      	      	 vvf[i].h+cc*(vvf[i+1].h-vvf[i].h),
      	      	      	      	 vvf[i].s+cc*(vvf[i+1].s-vvf[i].s));
      }
    }

//--------------------------------------------------------------------//
// ͂ɑΉOaCf[^Ԃ
// pp - 
    public function getGasByP(pp:Number):StateVariable{
      if(pp<=p[0]){
      	return StateVariable.create(t[0],pp,vvg[0]);
      }
      else if(pp>=p[p.length-1]){
      	return StateVariable.create(t[p.length-1],pp,vvg[p.length-1]);
      }
      else{
      	var i:int=PressureTable.serachIndex(0,p.length-1,pp,p);
      	var cc:Number=(pp-p[i])/(p[i+1]-p[i]);
      	return new StateVariable(t[i]+cc*(t[i+1]-t[i]),pp,
      	      	      	      	 vvg[i].v+cc*(vvg[i+1].v-vvg[i].v),
      	      	      	      	 vvg[i].u+cc*(vvg[i+1].u-vvg[i].u),
      	      	      	      	 vvg[i].h+cc*(vvg[i+1].h-vvg[i].h),
      	      	      	      	 vvg[i].s+cc*(vvg[i+1].s-vvg[i].s));
      }
    }

//--------------------------------------------------------------------//
// Ggs[ɑΉOaCf[^Ԃ
// ss - Ggs[
    public function getGasByS(ss:Number):StateVariable{
      if(ss>=vvg[0].s){
      	return StateVariable.create(t[0],p[0],vvg[0]);
      }
      else if(ss<=vvg[vvg.length-1].s){
      	return StateVariable.create(t[vvg.length-1],p[vvg.length-1],
      	      	      	      	    vvg[vvg.length-1]);
      }
      else{
      	var i:int=PressureTable.serachIndexS(0,vvg.length-1,ss,vvg);
      	var cc:Number=(ss-vvg[i].s)/(vvg[i+1].s-vvg[i].s);
      	return new StateVariable(t[i]+cc*(t[i+1]-t[i]),
      	      	      	      	 p[i]+cc*(p[i+1]-p[i]),
      	      	      	      	 vvg[i].v+cc*(vvg[i+1].v-vvg[i].v),
      	      	      	      	 vvg[i].u+cc*(vvg[i+1].u-vvg[i].u),
      	      	      	      	 vvg[i].h+cc*(vvg[i+1].h-vvg[i].h),ss);
      }
    }
  }
}
